# -*- Makefile -*-
#
# @file  Makefile.move
# @brief RTComponent makefile for "move component"
# @date  $Date$
#
# This file is generated by rtc-template with the following argments.
#
#   rtc-template -bpython,python,python,python,python,cxx,cxx,cxx,cxx,cxx --module-name=move 
#   --module-desc='generate target point in task frame' --module-version=1.0.0 --module-vendor=FUJISOFT Inc. 
#   --module-category=target_generator --module-comp-type=STATIC 
#   --module-act-type=SPORADIC --module-max-inst=10 
#   --inport=state:TimedLong --outport=frame:TimedFloatSeq 
#
#
# $Id$
#
CXXFLAGS = `rtm-config --cflags` -I.
LDFLAGS  = `rtm-config --libs`
SHFLAGS  = -shared

IDLC     = `rtm-config --idlc`
IDLFLAGS = `rtm-config --idlflags` -I`rtm-config --prefix`/include/rtm/idl
WRAPPER  = rtm-skelwrapper
WRAPPER_FLAGS = --include-dir="" --skel-suffix=Skel --stub-suffix=Stub

SKEL_OBJ = 
STUB_OBJ = 
IMPL_OBJ = 
OBJS     = move.o $(SKEL_OBJ) $(STUB_OBJ) $(IMPL_OBJ)

.SUFFIXES : .so

all: move.so moveComp

.cpp.o:
	rm -f $@
	$(CXX) $(CXXFLAGS) -c -o $@ $<

.o.so:
	rm -f $@
	$(CXX) $(SHFLAGS) -o $@ $(OBJS) $(LDFLAGS)

moveComp: moveComp.o $(OBJS)
	$(CXX) -o $@ $(OBJS) moveComp.o $(LDFLAGS) 


clean: clean_objs clean_skelstub
	rm -f *~

clean_objs:
	rm -f $(OBJS) moveComp.o move.so moveComp

clean_skelstub:
	rm -f *Skel.h *Skel.cpp
	rm -f *Stub.h *Stub.cpp



move.so: $(OBJS)
move.o: move.h 	 	
moveComp.o: moveComp.cpp move.cpp move.h 



# end of Makefile
