// -*- C++ -*-
/*!
 * @file  move.h
 * @brief forward kinema of PA10
 * @date  $Date$
 *
 * $Id$
 */

#ifndef MOVE_H
#define MOVE_H

#define LB 317
#define MOVABLE_RAD 860		//͈͔a  860[mm]

#include <rtm/Manager.h>
#include <rtm/DataFlowComponentBase.h>
#include <rtm/CorbaPort.h>
#include <rtm/DataInPort.h>
#include <rtm/DataOutPort.h>
#include <rtm/idl/BasicDataTypeSkel.h>

// Service implementation headers
// <rtc-template block="service_impl_h">

// </rtc-template>

// Service Consumer stub headers
// <rtc-template block="consumer_stub_h">

// </rtc-template>


#include <math.h>
#include <stdio.h>
#include <geo_std.h>

using namespace RTC;

class move
  : public RTC::DataFlowComponentBase
{
 public:
  move(RTC::Manager* manager);
  ~move();

  // The initialize action (on CREATED->ALIVE transition)
  // formaer rtc_init_entry()
 virtual RTC::ReturnCode_t onInitialize();

  // The finalize action (on ALIVE->END transition)
  // formaer rtc_exiting_entry()
  // virtual RTC::ReturnCode_t onFinalize();

  // The startup action when ExecutionContext startup
  // former rtc_starting_entry()
  // virtual RTC::ReturnCode_t onStartup(RTC::UniqueId ec_id);

  // The shutdown action when ExecutionContext stop
  // former rtc_stopping_entry()
  // virtual RTC::ReturnCode_t onShutdown(RTC::UniqueId ec_id);

  // The activated action (Active state entry action)
  // former rtc_active_entry()
 virtual RTC::ReturnCode_t onActivated(RTC::UniqueId ec_id);

  // The deactivated action (Active state exit action)
  // former rtc_active_exit()
  // virtual RTC::ReturnCode_t onDeactivated(RTC::UniqueId ec_id);

  // The execution action that is invoked periodically
  // former rtc_active_do()
 virtual RTC::ReturnCode_t onExecute(RTC::UniqueId ec_id);

  // The aborting action when main logic error occurred.
  // former rtc_aborting_entry()
  // virtual RTC::ReturnCode_t onAborting(RTC::UniqueId ec_id);

  // The error action in ERROR state
  // former rtc_error_do()
  // virtual RTC::ReturnCode_t onError(RTC::UniqueId ec_id);

  // The reset action that is invoked resetting
  // This is same but different the former rtc_init_entry()
  // virtual RTC::ReturnCode_t onReset(RTC::UniqueId ec_id);

  // The state update action that is invoked after onExecute() action
  // no corresponding operation exists in OpenRTm-aist-0.2.0
  // virtual RTC::ReturnCode_t onStateUpdate(RTC::UniqueId ec_id);

  // The action that is invoked when execution context's rate is changed
  // no corresponding operation exists in OpenRTm-aist-0.2.0
  // virtual RTC::ReturnCode_t onRateChanged(RTC::UniqueId ec_id);


 protected:
  // Configuration variable declaration
  // <rtc-template block="config_declare">
  
  // </rtc-template>

  /*!
   * 
   * - Name:  pos_x
   * - DefaultValue: 600
   */
  float m_pos_x;
  /*!
   * 
   * - Name:  pos_y
   * - DefaultValue: 0
   */
  float m_pos_y;
  /*!
   * 
   * - Name:  pos_z
   * - DefaultValue: 300
   */
  float m_pos_z;
  /*!
   * 
   * - Name:  rot_a
   * - DefaultValue: 0
   */
  float m_rot_a;
  /*!
   * 
   * - Name:  rot_b
   * - DefaultValue: 180
   */
  float m_rot_b;
  /*!
   * 
   * - Name: ftHgڕWl rot_c
   * - DefaultValue: 0
   */
  float m_rot_c;
  // </rtc-template>

  // DataInPort declaration
  // <rtc-template block="inport_declare">
  TimedLong m_state;
  InPort<TimedLong> m_stateIn;
  
  // </rtc-template>

  // DataOutPort declaration
  // <rtc-template block="outport_declare">
  TimedFloatSeq m_frame;
  OutPort<TimedFloatSeq> m_frameOut;
  
  // </rtc-template>

  // CORBA Port declaration
  // <rtc-template block="corbaport_declare">
  
  // </rtc-template>

  // Service declaration
  // <rtc-template block="service_declare">
  
  // </rtc-template>

  // Consumer declaration
  // <rtc-template block="consumer_declare">
  
  // </rtc-template>

 private:
  int dummy;

};

void make_inputdata(float vtrabc[6], float config[6]);
int can_move(float x, float y, float z);

extern "C"
{
  void moveInit(RTC::Manager* manager);
};

#endif // MOVE_H
