// -*-C++-*-
/*!
 * @file  com_pa10SVC_impl.cpp
 * @brief Service implementation code of com_pa10.idl
 *
 */

#include "com_pa10SVC_impl.h"

/*
 * Example implementational code for IDL interface ComPA10
 */
ComPA10SVC_impl::ComPA10SVC_impl()
{
  // Please add extra constructor code here.
}


ComPA10SVC_impl::~ComPA10SVC_impl()
{
  // Please add extra destructor code here.
}


/*
 * Methods corresponding to IDL attributes and operations
 */
CORBA::Long ComPA10SVC_impl::move_here_pa10()
{
  // Please insert your code here and remove the following warning pragma
#ifndef WIN32
  #warning "Code missing in function <CORBA::Long ComPA10SVC_impl::move_here_pa10()>"
#endif

  long err;
  ANGLE angle;

  std::cout << "+++++ move_here_pa10:start +++++" << std::endl;

  err = pa_get_agl(ARM0,&angle);
  std::cout << "pa_get_agl" << " " << err << std::endl;
  err = pa_exe_axs(ARM0,AXISALL,&angle,WM_WAIT);
  std::cout << "pa_exe_axs" << " " << err << std::endl;

  std::cout << "+++++ move_here_pa10:end   +++++" << std::endl;

  return(err);
}

CORBA::Long ComPA10SVC_impl::reset_pa10()
{
  // Please insert your code here and remove the following warning pragma
#ifndef WIN32
  #warning "Code missing in function <CORBA::Long ComPA10SVC_impl::reset_pa10()>"
#endif

  long err;

  std::cout << "+++++ reset_pa10:start     +++++" << std::endl;

  // initialize PA10 library
  err = pa_ini_sys();      
  std::cout << "pa_ini_sys" << " " << err << std::endl;
  // open ARM0
  err = pa_opn_arm(ARM0);
  std::cout << "pa_opn_arm" << " " << err << std::endl;
  // start ARM0
  err = pa_sta_arm(ARM0);
  std::cout << "pa_sta_arm" << " " << err << std::endl;
  // reset error infomation
  err = pa_rst_ctl(ARM0);
  std::cout << "pa_rst_ctl" << " " << err << std::endl;
  err = move_here_pa10();

  std::cout << "+++++ reset_pa10:end       +++++" << std::endl;
  return(err);
}

CORBA::Long ComPA10SVC_impl::init_pa10()
{
  // Please insert your code here and remove the following warning pragma
#ifndef WIN32
  #warning "Code missing in function <CORBA::Long ComPA10SVC_impl::init_pa10()>"
#endif

  int i;
  long err;
  ANGLE an;
  PARAM para;

  std::cout << "+++++ init_pa10:start      +++++" << std::endl;
  err = reset_pa10();

  // init position setting
  an.s1 =  0.0;
  an.s2 =  M_PI/4;
  an.s3 =  0.0;
  an.e1 =  M_PI/4;
  an.e2 =  0.0;
  an.w1 =  M_PI/2;
//  an.w2 =  0.0;
  an.w2 =  M_PI;
  err = pa_exe_axs(ARM0,AXISALL,&an,WM_WAIT);
  std::cout << "pa_exe_axs" << " " << err << std::endl;

//  err = pa_exe_esc(ARM0,WM_WAIT);
//  std::cout << "pa_exe_esc" << " " << err << std::endl;

  err = pa_get_prm(ARM0, &para);
  std::cout << "pa_get_prm" << " " << err << std::endl;
  for(i=0;i<7;i++) {
    m_vel_lim[i] = para.vel[i];
  }

  std::cout << "+++++ init_pa10:end        +++++" << std::endl;

  return(err);
}

CORBA::Long ComPA10SVC_impl::on_pa10()
{
  // Please insert your code here and remove the following warning pragma
#ifndef WIN32
  #warning "Code missing in function <CORBA::Long ComPA10SVC_impl::on_pa10()>"
#endif

  int i;
  long err;
  float j_vel[7];

  std::cout << "+++++ on_pa10:start        +++++" << std::endl;

  for(i=0;i<7;i++) j_vel[i] = 0.0;

  // timeout setting(ms)
  err=pa_set_tim(ARM0,100);
  std::cout << "pa_set_tim" << " " << err << std::endl;
  err=pa_mod_vel(ARM0,VM_ONE,S1|S2|S3|E1|E2|W1|W2);
  std::cout << "pa_mod_vel" << " " << err << std::endl;
  err=pa_odr_vel(ARM0,j_vel);
  std::cout << "pa_odr_vel" << " " << err << std::endl;

  std::cout << "+++++ on_pa10:end          +++++" << std::endl;

  return(err);
}

CORBA::Long ComPA10SVC_impl::off_pa10()
{
  // Please insert your code here and remove the following warning pragma
#ifndef WIN32
  #warning "Code missing in function <CORBA::Long ComPA10SVC_impl::off_pa10()>"
#endif

  int i;
  long err;
  float j_vel[7];

  std::cout << "+++++ off_pa10:start       +++++" << std::endl;

  for(i=0;i<7;i++) j_vel[i] = 0.0;
  err=pa_odr_vel(ARM0,j_vel);
  std::cout << "pa_odr_vel" << " " << err << std::endl;
  err=pa_sus_arm(ARM0,WM_WAIT);
  std::cout << "pa_sus_arm" << " " << err << std::endl;

  std::cout << "+++++ off_pa10:end         +++++" << std::endl;

  return(err);
}

CORBA::Long ComPA10SVC_impl::end_pa10()
{
  // Please insert your code here and remove the following warning pragma
#ifndef WIN32
  #warning "Code missing in function <CORBA::Long ComPA10SVC_impl::end_pa10()>"
#endif

  long err;

  std::cout << "+++++ end_pa10:start       +++++" << std::endl;

  //  pa_get_cnt(ARM0, &i_tmp);
  //  printf("cnt1=%ld\n",i_tmp);
  err=pa_exe_hom(ARM0, WM_WAIT);
  std::cout << "pa_exe_hom" << " " << err << std::endl;
  //  pa_get_cnt(ARM0, &i_tmp);
  //  printf("cnt2=%ld\n",i_tmp);
  Sleep(5);
  //  pa_get_cnt(ARM0, &i_tmp);
  //  printf("cnt3=%ld\n",i_tmp);
  err=pa_ext_arm(ARM0);
  std::cout << "pa_ext_arm" << " " << err << std::endl;
  err=pa_cls_arm(ARM0);
  std::cout << "pa_cls_arm" << " " << err << std::endl;
  err=pa_ter_sys(); 
  std::cout << "pa_ter_sys" << " " << err << std::endl;

  std::cout << "+++++ end_pa10:end       +++++" << std::endl;
  return(err);
}

void ComPA10SVC_impl::set_flg(CORBA::Long flg)
{
  // Please insert your code here and remove the following warning pragma
#ifndef WIN32
  #warning "Code missing in function <void ComPA10SVC_impl::set_flg(CORBA::Long flg)>"
#endif

    m_act_flg = flg;
}



// End of example implementational code



