// -*-C++-*-
/*!
 * @file  com_pa10SVC_impl.h
 * @brief Service implementation header of com_pa10.idl
 *
 */

#include "com_pa10Skel.h"
#include <iostream>
#include <pa.h>
#include <paerr.h>

#define _USE_MATH_DEFINES
#include <math.h>

#ifndef COM_PA10SVC_IMPL_H
#define COM_PA10SVC_IMPL_H
 
/*
 * Example class implementing IDL interface ComPA10
 */
class ComPA10SVC_impl
 : public virtual POA_ComPA10,
   public virtual PortableServer::RefCountServantBase
{
 private:
   // Make sure all instances are built on the heap by making the
   // destructor non-public
   //virtual ~ComPA10SVC_impl();

 public:
   // standard constructor
   ComPA10SVC_impl();
   virtual ~ComPA10SVC_impl();

   // attributes and operations
   CORBA::Long move_here_pa10();
   CORBA::Long reset_pa10();
   CORBA::Long init_pa10();
   CORBA::Long on_pa10();
   CORBA::Long off_pa10();
   CORBA::Long end_pa10();
   void set_flg(CORBA::Long flg);

   CORBA::Long m_act_flg;
   CORBA::Float m_vel_lim[7+2];
};



#endif // COM_PA10SVC_IMPL_H


