#!/usr/bin/env python
# -*- Python -*-

MyRtcDir = "C:\PA10RMRC\pa10\\src"

import sys
import new
import visual
from math import *
save_path = sys.path[:]
sys.path.append(MyRtcDir+'\\tools\\geo')
# from geo import *
sys.path = save_path

def make_circle(r=100, y=0, z=0, 
                n_seg=12, start=0, end=None) :
    if not end :
        end = n_seg - 1
    rslt = []
    for i in range(start,end+1):
#  rslt.append(visual.vector(r*cos(2*pi/n_seg*i),r*sin(2*pi/n_seg*i)+y,z))
        rslt.append([r*cos(2*pi/n_seg*i),r*sin(2*pi/n_seg*i)+y,z])
    return rslt
def make_koban_points(l, r, z) :
    return (make_circle(r, 0.5*l, z, end=6) + 
                make_circle(r, -0.5*l, z, start=6))
def make_koban_sui_dai(l, r1, z1, r2, z2) :
   pp = make_koban_points(l,r1,0)
   pp += make_koban_points(l,r1,z1)
   pp += make_koban_points(l,r2,z2)
   return visual.convex(pos=pp)
              
#
# mks
# 
class Link(visual.frame) :
    def __init__(self) :
        visual.frame.__init__(self)
        self.joint = None
        self.sc =1.0
        self.angle=0.0
    def set_joint(self, val) :
        if self.joint=="tx" :
            self.pos=(self.sc*val,0,0)
        elif self.joint=="ty" :
            self.pos=(0,self.sc*val,0)
        elif self.joint=="tz" :
            self.pos=(0,0,self.sc*val)
        elif self.joint=="rx" :
            diff = self.sc*val - self.angle
            self.angle += diff
            self.rotate(axis=(1,0,0),angle=diff)
        elif self.joint=="ry" :
            diff = self.sc*val - self.angle
            self.angle += diff
            self.rotate(axis=(0,1,0),angle=diff)
        elif self.joint=="rz" :
            diff = self.sc*val - self.angle
            self.angle += diff
            self.rotate(axis=(0,0,1),angle=diff)
#
# base
#
base=Link()
base.r = 0.117
base.h = 0.200
base.b  = visual.cylinder(axis=(0.0, 0.0, base.h), radius=base.r)
#base = visual.frame()
base.rotate(axis=(0,0,1),angle=-pi/2)
base.b.frame=base
#
# link 1
#
link1=Link()
link1.r = 0.117
link1.h = 0.020

link1.a1=visual.box(length=0.010,height=0.170,width=0.01)
#a2=visual.cylinder(pos=(0,0,0.01),axis=(0.0, 0.0, l1_h),radius=l1_r)
#a3=visual.box(pos=(0,0.168,0),length=0.150,height=0.150,width=0.1)
#a4=visual.box(pos=(0,-0.168,0),length=0.150,height=0.150,width=0.1)
link1.a2_v  =make_circle(link1.r,n_seg=24,start=3,end=9)
link1.a2_v +=make_circle(link1.r,n_seg=24,start=15,end=21)
link1.a2_v +=make_circle(link1.r,z=link1.h,n_seg=24,start=3,end=9)
link1.a2_v +=make_circle(link1.r,z=link1.h,n_seg=24,start=15,end=21)
link1.a2= visual.convex(pos=link1.a2_v)
link1.l = 0.055
link1.r1 = 0.060
link1.z1 = 0.020
link1.r2 = 0.045
link1.z2 = 0.060

link1.l1=make_koban_sui_dai(link1.l,link1.r1,link1.z1,link1.r2,link1.z2)
link1.l2=link1.l1.__copy__()
link1.f1=visual.frame()
link1.f2=visual.frame()
link1.l1.frame=link1.f1
link1.l2.frame=link1.f2
link1.f1.rotate(axis=(1,0,0),angle=pi/2)
link1.f1.pos=(0,-0.080,0.090)
link1.l1.color=visual.color.green
link1.f2.rotate(axis=(1,0,0),angle=-pi/2)
link1.f2.pos=(0,0.075,0.090)
link1.l2.color=visual.color.green
link1.f3=visual.frame()
link1.a2.frame=link1.f3
link1.f3.rotate(axis=(0,0,1),angle=pi/2)

#link1=visual.frame()
link1.a1.frame=link1
#a3.frame=link1
#a4.frame=link1
link1.f1.frame=link1
link1.f2.frame=link1
link1.f3.frame=link1
link1.pos=(0,0,base.h)
link1.frame=base
link1.joint="rz"

#
# link 2
#
link2=Link()
link2.r=0.060
link2.h=0.210
link2.off=0.010
link2.r2=0.060
link2.h2=0.150
link2.l1=visual.cylinder(pos=(0,0,0.07-link2.off),
                      axis=(0,0,link2.h+link2.off),radius=link2.r)
link2.l2=visual.cylinder(pos=(-0.005,-link2.h2/2,0.0100-link2.off),
                    axis=(0,link2.h2,0),radius=link2.r2)
#link2=visual.frame()
link2.l1.frame=link2
link2.l2.frame=link2
link2.pos=(0,0,0.115)
link2.frame=link1
link2.joint="ry"

#
# link 3
#
link3=Link()
link3.r=0.060
link3.h=0.050
link3.off=0.020
link3.l=0.080
link3.r1=0.060
link3.z1=0.025
link3.r2=0.040
link3.z2=0.050

link3.b1=visual.cylinder(axis=(0,0, link3.h+link3.off),radius=link3.r)
#b2=visual.box(pos=(0,0.120,0.030),length=0.150,height=0.150,width=0.1)
#b3=visual.box(pos=(0,-0.120,0.030),length=0.150,height=0.150,width=0.1)
link3.b4=visual.box(pos=(0,0,0.040),length=0.010,height=0.130,width=0.010)
link3.l1=make_koban_sui_dai(link3.l,link3.r1,link3.z1,link3.r2,link3.z2)
link3.l2=link3.l1.__copy__()
link3.f1=visual.frame()
link3.f2=visual.frame()
link3.l1.frame=link3.f1
link3.l2.frame=link3.f2
link3.f1.rotate(axis=(1,0,0),angle=pi/2)
link3.f1.pos=(0,-0.050,0.120)
link3.l1.color=visual.color.green
link3.f2.rotate(axis=(1,0,0),angle=-pi/2)
link3.f2.pos=(0,0.050,0.120)
link3.l2.color=visual.color.green
# link3=visual.frame()
link3.b1.frame=link3
#b2.frame=link3
#b3.frame=link3
link3.b4.frame=link3
link3.f1.frame=link3
link3.f2.frame=link3
link3.frame=link2
link3.pos=(0,0,link2.h+link2.off+link3.r)
link3.joint="rz"

#
# link 4
#
link4=Link()
link4.r=0.05
link4.h=0.10
link4.off=0.01

link4.l1=visual.cylinder(axis=(0,0,link4.h),radius=link4.r)
link4.l1.rotate(axis=(1,0,0),angle=pi/2)
link4.l1.pos=(0,link4.h/2,0)
link4.c1 = make_circle(r=0.050,z=0)
link4.c1 += make_circle(r=0.030,z=0.050)
link4.c1v=visual.convex(pos=link4.c1)
link4.c2 = make_circle(r=0.030,z=0.050)
link4.c2 += make_circle(r=0.040,z=0.100)
link4.c2v=visual.convex(pos=link4.c2)
link4.c3 = make_circle(r=0.040,z=0.100)
link4.c3 += make_circle(r=0.050,z=0.150)
link4.c3v=visual.convex(pos=link4.c3)
link4.c4 = make_circle(r=0.050,z=0.150)
link4.c4 += make_circle(r=0.050,z=0.200)
link4.c4v=visual.convex(pos=link4.c4)
link4.l2=visual.frame()
link4.c1v.frame=link4.l2
link4.c2v.frame=link4.l2
link4.c3v.frame=link4.l2
link4.c4v.frame=link4.l2
link4.l2.pos=(0,0,0.05)
#link4=visual.frame()
link4.l1.frame=link4
link4.l2.frame=link4
link4.frame=link3
link4.pos=(0,0,link3.l+link3.r+0.03)
link4.joint="ry"
#
# link5
#
link5=Link()
link5.r=0.06
link5.h=0.06
link5.off=0.01
link5.l=0.2
link5.r1=0.04
link5.z1=0.01
link5.r2=0.03
link5.z2=0.03
link5.d1=visual.box(pos=(0,0,0.030),length=0.010,height=0.130,width=0.01)
link5.d2=visual.cylinder(axis=(0,0,link5.h+link5.off),radius=link5.r)
#d3=visual.box(pos=(0,0.120,0.030),length=0.150,height=0.150,width=0.1)
#d4=visual.box(pos=(0,-0.120,0.030),length=0.150,height=0.150,width=0.1)
link5.l1=make_koban_sui_dai(link5.l,link5.r1,link5.z1,link5.r2,link5.z2)
link5.l2=link5.l1.__copy__()
link5.f1=visual.frame()
link5.f2=visual.frame()
link5.l1.frame=link5.f1
link5.l2.frame=link5.f2
link5.f1.rotate(axis=(1,0,0),angle=pi/2)
link5.f1.pos=(0,-0.05,0.14)
link5.f2.rotate(axis=(1,0,0),angle=-pi/2)
link5.f2.pos=(0,0.05,0.14)
link5.l1.color=visual.color.green
link5.l2.color=visual.color.green
#link5=visual.frame()
link5.d1.frame=link5
link5.d2.frame=link5
link5.f1.frame=link5
link5.f2.frame=link5
link5.frame=link4
link5.pos=(0,0,link5.l+0.05)
link5.joint="rz"
#
# link6
#
link6=Link()
link6.r=0.035
link6.h=0.09
link6.off=0.15

link6.l1=visual.cylinder(axis=(0,0,link6.h),radius=link6.r)
link6.l1.rotate(axis=(1,0,0),angle=pi/2)
link6.l1.pos=(0,link6.h/2,0)
link6.e1 = make_circle(r=0.035,z=0)
link6.e1 += make_circle(r=0.035,z=0.050)
link6.e1v=visual.convex(pos=link6.e1)
link6.e2 = make_circle(r=0.035,z=0.050)
link6.e2 += make_circle(r=0.025,z=0.070)
link6.e2v=visual.convex(pos=link6.e2)
link6.e3 = make_circle(r=0.025,z=0.070)
link6.e3 += make_circle(r=0.025,z=0.110)
link6.e3v=visual.convex(pos=link6.e3)
link6.l2=visual.frame()
link6.e1v.frame=link6.l2
link6.e2v.frame=link6.l2
link6.e3v.frame=link6.l2
link6.l2.pos=(0,0,-0.145)

link6.g1 = make_circle(r=0.025,z=0)
link6.g1 += make_circle(r=0.036,z=0.030)
link6.g1v=visual.convex(pos=link6.g1)
link6.g2 = make_circle(r=0.036,z=0.030)
link6.g2 += make_circle(r=0.036,z=0.050)
link6.g2v=visual.convex(pos=link6.g2)
link6.l3=visual.frame()
link6.g1v.frame=link6.l3
link6.g2v.frame=link6.l3
link6.l3.pos=(0,0,0.035)
#link6=visual.frame()
link6.l1.frame=link6
link6.l2.frame=link6
link6.l3.frame=link6
link6.frame=link5
link6.pos=(0,0,link6.off+0.100)
link6.joint="ry"
#
# link7
#
link7=Link()
link7.r=0.03
link7.h=0.03

link7.l1=visual.cylinder(pos=(0,0,-link7.h/2),
                     axis=(0,0,link7.h),radius=link7.r)
#link7=visual.frame()
link7.l1.frame=link7
link7.frame=link6
link7.pos=(0,0,0.080)
link7.joint="rz"
#
# hand
#
hand=Link()
hand.ha=visual.cylinder(axis=(0,0,0.085),radius=0.04)
hand.fr=visual.box(length=0.030,height=0.010,width=0.07)
hand.fr0=(0,-0.005,0.125)
hand.fr.pos=hand.fr0
hand.fl=visual.box(length=0.030,height=0.010,width=0.07)
hand.fl0=(0,0.005,0.125)
hand.fl.pos=hand.fl0
#hand=visual.frame()
hand.ha.frame=hand
hand.fr.frame=hand
hand.fl.frame=hand
#hand.rotate(axis=(0,0,1),angle=-pi/4)
hand.rotate(axis=(0,0,1),angle=0)
hand.frame=link7

def hand_open(self,val):
  self.fr.pos=(self.fr0[0],self.fr0[1]-val/2,self.fr0[2])
  self.fl.pos=(self.fl0[0],self.fl0[1]+val/2,self.fl0[2])

hand.set_joint=new.instancemethod(hand_open,hand,hand.__class__)
